/*

Easy Grade Pro 3.5-3.6 Decryption of Security Password
by xoclipse
xoclipse@cox.net
http://xoclipse.fraghosts.net

*/

#include <windows.h>
#include <stdio.h>

//prototypes
int checkArgs(int argc);
void openFileAndGetPass(char *path);
void decryptPasswordAndPrint(char *password);
void getEncryptedPasswordFromStdIn();
void displayCredits();

int main(int argc, char **argv[]) 
{
	int argsResult;

	displayCredits();
	argsResult = checkArgs(argc);

	if(argsResult == 1) { //they passed us filename(i.e dragged and dropped gradebook)
		openFileAndGetPass((char*)argv[1]);
	}
	else { //ask for string
		getEncryptedPasswordFromStdIn();
	}

	system("PAUSE");
	return 0;
}
//------------------------------------------------------------------------------------------
int checkArgs(int argc)
{
	if(argc > 1) {
		return 1;
	}
	else if(argc < 2) {
		return 0;
	}
}
//-----------------------------------------------------------------------------------------
void openFileAndGetPass(char *path)
{
	FILE *file;
	int size;
	char *buf = NULL;
	char delims[20] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

	file = fopen(path, "rb"); //open the path up with reading and binary settings
	if(file == NULL) {
		printf("Couldn't open file at path: %s\n", path);
		return;
	}

	fseek(file, 0, SEEK_END); //go to end
	size = ftell(file); //record the size of buf
	rewind(file); //go back to beggining

	buf = (char*)malloc(size+1); //allocate the buf
	if(buf == NULL) { //couldn't allocate memory
		printf("Couldn't allocate %d bytes\n", size);
		return;
	}

	fread(buf, 1, size, file);

	//increment buf until we get to the pass
	for(int x = 0; x < size; x++) {
		
		if(memcmp(buf, delims, 10) == 0) {
			for(;*buf == 0; buf++);
			x = size;
			break;
		}	
		buf++;
	}

	decryptPasswordAndPrint(buf);

	fclose(file);
}
//----------------------------------------------------------------------------------------
void decryptPasswordAndPrint(char *password)
{
	char *decrypted = NULL;
	decrypted = (char*)malloc(strlen(password)+1);

	printf("Encrypted Password: %s\n", password);

	for(int x = 0; x < strlen(password); x++) {
		decrypted[x] = password[x] - 0x11;
	}
	decrypted[strlen(password)] = 0;

	printf("Decrypted Password: %s\n", decrypted);

	if(decrypted != NULL) free(decrypted);
}
//----------------------------------------------------------------------------------------
void getEncryptedPasswordFromStdIn()
{
	char buf[256];
	printf("Please enter the encrypted password: ");

	scanf("%s", &buf);

	decryptPasswordAndPrint(buf);
}
//-------------------------------------------------------------------------
void displayCredits() 
{
		printf("\
------------------------------------------\n\
Easy Grade Pro Gradebook Password Cracker\n\
Cracked by xoclipse\n\
http://xoclipse.fraghosts.net\n\
------------------------------------------\n");
}
//------------------------------------------------------------------------------------------